﻿using System;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;
using System.Text;
using System.Security.Cryptography;

[Serializable]
public class CryptString : IXmlSerializable
{
    private string _value;
    private static readonly byte[] entropy = new byte[] { 0x85, 0x54, 0xd0, 0x5d, 0xba, 0x2a, 0x52, 0x58, 0x73, 0x48, 0x03, 0xb5, 0xc4, 0x52, 0xd0, 0xf6 };
    private static bool _encryption = true;
    public static bool Encryption
    {
        get
        {
            return _encryption;
        }
        set
        {
            _encryption = value;
        }
    }
    private static bool _ignoreCipherError = false;
    public static bool IgnoreCipherError
    {
        get
        {
            return _ignoreCipherError;
        }
        set
        {
            _ignoreCipherError = value;
        }
    }

    public CryptString()
    {
        _value = "";
    }

    public CryptString(string value)
    {
        _value = value;
    }

    public XmlSchema GetSchema()
    {
        return null;
    }

    public void ReadXml(XmlReader reader)
    {
        string source = reader.ReadElementContentAsString();

        if (_encryption) {
            if (source.Length == 0) {
                _value = "";
            }
            else {
                try {
                    byte[] encryptedData = System.Convert.FromBase64String(source);
                    _value = Encoding.UTF8.GetString(ProtectedData.Unprotect(encryptedData, entropy, DataProtectionScope.LocalMachine));
                }
                catch (Exception e) {
                    if (!_ignoreCipherError) throw e;
                    else _value = "";
                }
            }
        }
        else {
            _value = source;
        }
    }

    public void WriteXml(XmlWriter writer)
    {
        if (_encryption) {
            string encrypted = "";
            if (_value.Length > 0) {
                byte[] rawData = Encoding.UTF8.GetBytes(_value);
                encrypted = System.Convert.ToBase64String(ProtectedData.Protect(rawData, entropy, DataProtectionScope.LocalMachine));
            }
            writer.WriteValue(encrypted);
        }
        else {
            writer.WriteValue(_value);
        }
    }

    public static implicit operator string(CryptString o)
    {
        return o == null ? default(string) : o._value;
    }

    public static implicit operator CryptString(string o)
    {
        return o == default(string) ? null : new CryptString { _value = o };
    }

    public override string ToString()
    {
        return _value;
    }

    public override bool Equals(object obj)
    {
        if (obj.GetType() != this.GetType()) return false;
        return _value.Equals(((CryptString)obj)._value);
    }

    public override int GetHashCode()
    {
        return _value.GetHashCode();
    }
}
