﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.ServiceProcess;
using System.Configuration.Install;
using System.Reflection;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace MyDNSUpdate
{
    static class Program
    {
        public static string appName = Assembly.GetEntryAssembly().GetName().Name;

        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static int Main(string[] args)
        {
            bool ret = false;

            if (args.Length > 0) {
                if (args[0] == "s") {
                    ServiceBase[] ServicesToRun;
                    ServicesToRun = new ServiceBase[] 
			        { 
				        new Service1() 
			        };
                    ServiceBase.Run(ServicesToRun);
                }
                else if (args[0] == "i") {
                    if (Service1.IsRegistered()) {
                        MessageBox.Show("Already installed.");
                    }
                    else {
                        ret = Service1.Register();
                    }
                }
                else if (args[0] == "u") {
                    if (Service1.IsRegistered()) {
                        ret = Service1.Unregister();
                    }
                }
                else {
                    AppRun(args[0]);
                }
            }
            else {
                AppRun("");
            }

            return ret ? 0 : 1;
        }

        static void AppRun(string arg)
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            try {
                Application.Run(new Form1(arg));
            }
            catch (Exception e) {
                MessageBox.Show(e.Message);
            }
        }
    }
}
